searchNodes=[{"doc":"Params provide some helpers method to work with parameters","ref":"Tarams.html","title":"Tarams","type":"module"},{"doc":"","ref":"Tarams.html#cast!/2","title":"Tarams.cast!/2","type":"function"},{"doc":"Cast and validate params with given schema. See Tarams.Schema for instruction on how to define a schema And then use it like this def index ( conn , params ) do index_schema = %{ status : [ type : :string , required : true ] , type : [ type : :string , in : [ &quot;type1&quot; , &quot;type2&quot; , &quot;type3&quot; ] ] , keyword : [ type : :string , length : [ min : 3 , max : 100 ] ] , } with { :ok , data } &lt;- Tarams . cast ( params , index_schema ) do # do query data else { :error , errors } -&gt; IO . puts ( errors ) end end","ref":"Tarams.html#cast/2","title":"Tarams.cast/2","type":"function"},{"doc":"","ref":"Tarams.html#cast_array/3","title":"Tarams.cast_array/3","type":"function"},{"doc":"Clean all nil field from params, support nested map and list. Example params = %{ &quot;keyword&quot; =&gt; nil , &quot;email&quot; =&gt; nil , &quot;type&quot; =&gt; &quot;customer&quot; } Tarams . clean_nil ( params ) # =&gt; %{&quot;type&quot; =&gt; &quot;customer&quot;} params = %{ user_ids : [ 1 , 2 , nil ] } Tarams . clean_nil ( params ) # =&gt; %{user_ids: [1, 2]}","ref":"Tarams.html#clean_nil/1","title":"Tarams.clean_nil/1","type":"function"},{"doc":"A plug which do srubbing params Use in Router defmodule MyApp.Router do ... plug Tarams . plug_scrub ... end Use in controller plug Tarams . plug_scrub when action in [ :index , :show ] # or specify which field to scrub plug Tarams . plug_scrub , [ &quot;id&quot; , &quot;keyword&quot; ] when action in [ :index , :show ]","ref":"Tarams.html#plug_scrub/2","title":"Tarams.plug_scrub/2","type":"function"},{"doc":"Convert all parameter which value is empty string or string with all whitespace to nil. It works with nested map and list too. Example params = %{ &quot;keyword&quot; =&gt; &quot; &quot; , &quot;email&quot; =&gt; &quot;&quot; , &quot;type&quot; =&gt; &quot;customer&quot; } Tarams . scrub_param ( params ) # =&gt; %{&quot;keyword&quot; =&gt; nil, &quot;email&quot; =&gt; nil, &quot;type&quot; =&gt; &quot;customer&quot;} params = %{ user_ids : [ 1 , 2 , &quot;&quot; , &quot; &quot; ] } Tarams . scrub_param ( params ) # =&gt; %{user_ids: [1, 2, nil, nil]}","ref":"Tarams.html#scrub_param/1","title":"Tarams.scrub_param/1","type":"function"},{"doc":"This is only a specification to define a schema to use with Tarams.Params.cast and Tarams.Contract.validate Schema is just a map or keyword list that follow some simple conventions. Map's key is the field name and the value is a keyword list of field specifications. Example %{ name : [ type : :string , format : ~r/\d{4}/ ] , age : [ type : :integer , number : [ min : 15 , max : 50 ] ] . skill : [ type : { :array , :string } , length : [ min : 1 , max : 10 ] ] } If you only specify type of data, you can write it shorthand style like this %{ name : :string , age : :integer , skill : { :array , :string } } I. Field type Built-in types A type could be any of built-in supported types: boolean string | binary integer float number (integer or float) date time datetime | utc_datetime : date time with time zone naive_datetime : date time without time zone map keyword {array, type} array of built-in type, all item must be the same type Other types Custom type may be supported depends on module. Nested types Nested types could be a another schema or list of schema %{ user : [ type : %{ name : [ type : :string ] } ] } Or list of schema %{ users : [ type : { :array , %{ name : [ type : :string ] } } ] } Alias Alias allow set a new key for value when using with Taram.cast schema = %{ email : [ type : :string , as : :user_email ] } Tarams . cast ( %{ email : &quot;xx@yy.com&quot; } , schema ) #&gt; {:ok, %{user_email: &quot;xx@yy.com&quot;}} II. Field casting and default value These specifications is used for casting data with Tarams.Params.cast 1. Default value Is used when the given field is missing or nil. Default could be a value %{ status : [ type : :string , default : &quot;active&quot; ] } Or a function/0 , this function will be invoke each time data is casted %{ published_at : [ type : :datetime , default : &amp; DateTime . utc_now / 0 ] } 2. Custom cast function You can provide a function to cast field value instead of using default casting function by using cast_func: &lt;function/1&gt; %{ published_at : [ type : :datetime , cast_func : &amp; DateTime . from_iso8601 / 1 ] } III. Field validation These validation are supported by Tarams.Validator 1. Type validation Type specification above could be used for validating or casting data. 2. Numeric validation Support validating number value. These are list of supported validations: equal_to greater_than_or_equal_to | min greater_than less_than less_than_or_equal_to | max Define validation: number: [&lt;name&gt;: &lt;value&gt;, ...] Example %{ age : [ type : :integer , number : [ min : 1 , max : 100 ] ] } 3. Length validation Validate length of supported types include string , array , map , tuple , keyword . Length condions are the same with Numeric validation Define validation: length: [&lt;name&gt;: &lt;value&gt;, ...] Example %{ skills : [ type : { :array , :string } , length : [ min : 0 , max : 5 ] ] } 4. Format validation Check if a string match a given pattern. Define validation: format: &lt;Regex&gt; Example %{ year : [ type : :string , format : ~r/year: \d{4}/ ] } 5. Inclusion and exclusion validation Check if value is included or not included in given enumerable ( array , map , or keyword ) Define validation: in: &lt;enumerable&gt; or not_in: &lt;enumerable&gt; Example %{ status : [ type : :string , in : [ &quot;active&quot; , &quot;inactive&quot; ] ] , selected_option : [ type : :integer , not_in : [ 2 , 3 ] ] } 6. Custom validation function You can provide a function to validate the value. Define validation: func: &lt;function&gt; Function must be follow this signature @spec func ( value :: any ( ) ) :: :ok | { :error , message :: String . t ( ) }","ref":"Tarams.Schema.html","title":"Tarams.Schema","type":"module"},{"doc":"Expand short-hand type syntax to full syntax field : :string -&gt; field : [ type : :string ] field : { :array , :string } -&gt; field : [ type : { :array , :string } ] field : % { #embedded} -&gt; field: [type: %{#embedded}]","ref":"Tarams.Schema.html#expand/1","title":"Tarams.Schema.expand/1","type":"function"},{"doc":"Cast data to target type. Much code of this module is borrowed from Ecto.Type","ref":"Tarams.Type.html","title":"Tarams.Type","type":"module"},{"doc":"","ref":"Tarams.Type.html#cast!/2","title":"Tarams.Type.cast!/2","type":"function"},{"doc":"","ref":"Tarams.Type.html#cast/2","title":"Tarams.Type.cast/2","type":"function"},{"doc":"Phoenix request params validation library. Warning: Tarams v1.0.0 APIs is not back compatible Tarams Why Tarams Installation Usage Define schema Default value Custom cast function 1. Custom cast fuction accept value only 2. Custom cast function accept value and current object 3.Custom cast function accept tuple {M, f} Nested schema Transform data Field name alias Convert data Validation Contributors","ref":"readme.html","title":"Tarams","type":"extras"},{"doc":"- Reduce code boilerplate - Shorter schema definition - Default function which generate value each casting time - Custom validation functions - Custom parse functions","ref":"readme.html#why-tarams","title":"Tarams - Why Tarams","type":"extras"},{"doc":"Available in Hex , the package can be installed by adding tarams to your list of dependencies in mix.exs : def deps do [ { :tarams , &quot;~&gt; 1.0.0&quot; } ] end","ref":"readme.html#installation","title":"Tarams - Installation","type":"extras"},{"doc":"@index_params_schema %{ keyword : :string , status : [ type : :string , required : true ] , group_id : [ type : :integer , numer : [ greater_than : 0 ] ] } def index ( conn , params ) do with { :ok , better_params } &lt;- Tarams . cast ( params , @index_params_schema ) do # do anything with your params else { :error , errors } -&gt; # return params error end end","ref":"readme.html#usage","title":"Tarams - Usage","type":"extras"},{"doc":"Schema is just a map and it can be nested. Each field is defined as &lt;field_name&gt;: [&lt;field_spec&gt;, ...] Or short form &lt;field_name&gt;: &lt;type&gt; Field specs is a keyword list thay may include: type is required, Tarams support same data type as Ecto . I borrowed code from Ecto default : default value or default function cast_func : custom cast function number, format, length, in, not_in, func, required are available validations as : alias key you will receive from Tarams.cast if casting is succeeded Default value You can define a default value for a field if it's missing from the params. schema = %{ status : [ type : :string , default : &quot;pending&quot; ] } Or you can define a default value as a function. This function is evaluated when Tarams.cast gets invoked. schema = %{ date : [ type : :utc_datetime , default : &amp; Timex . now / 0 ] } Custom cast function You can define your own casting function, tarams provide cast_func option. Your cast_func must follows this spec 1. Custom cast fuction accept value only fn ( any ) :: { :ok , any } | { :error , binary } | :error def my_array_parser ( value ) do if is_binary ( value ) do ids = String . split ( value , &quot;,&quot; ) |&gt; Enum . map ( &amp; String . to_integer ( &amp;1 ) ) { :ok , ids } else { :error , &quot;Invalid string&quot; end end schema = %{ user_id : [ type : { :array , :integer } , cast_func : &amp; my_array_parser / 1 ] } Tarams . cast ( %{ user_id : &quot;1,2,3&quot; } , schema ) This is a demo parser function. 2. Custom cast function accept value and current object data = %{ name : &quot;tada&quot; , bold : true } schema = %{ name : [ type : :string , cast_func : fn value , data -&gt; { :ok , ( if data . bold , do : String . upcase ( value ) , else : value ) } end ] } Tarams . cast ( data , schema ) # &gt; %{name: &quot;TADA&quot;} 3.Custom cast function accept tuple {M, f} Your cast function must accept 2 arguments defmodule MyModule do def upcase ( value , data ) do { :ok , ( if data . bold , do : String . upcase ( value ) , else : value ) } end end data = %{ name : &quot;tada&quot; , bold : true } schema = %{ name : [ type : :string , cast_func : { MyModule , :upcase } ] } Tarams . cast ( data , schema ) # &gt; %{name: &quot;TADA&quot;} Nested schema With Tarams you can parse and validate nested map and list easily @my_schema %{ status : :string , pagination : %{ page : [ type : :integer , number : [ min : 1 ] ] , size : [ type : :integer , number : [ min : 10 , max : 100 &quot; ] ] } } Or nested list schema @user_schema %{ name : :string , email : [ type : :string , required : true ] addresses : [ type : { :array , %{ street : :string , district : :string , city : :string } } ] }","ref":"readme.html#define-schema","title":"Tarams - Define schema","type":"extras"},{"doc":"Field name alias You can set alias name for schema fields data = %{ name : &quot;tada&quot; } schema = %{ name : [ type : :string , as : :full_name ] } Tarams . cast ( data , schema ) # &gt; %{full_name: &quot;tada&quot;} Convert data You can specify a function similar to cast_func to manipulate data after casted. However data object passed to transform function is original data before casting. data = %{ status : 10 } schema = % { name : [ type : :string , into : fn value -&gt; { :ok , &quot;name: \#{ value } }&quot; end ] } Tarams . cast ( data , schema ) # &gt; %{name: &quot;name: tada&quot;} Transform function can return tuple {:ok, value} , {:error, message} or value directly. schema = %{ value : [ type : :integer , into : &amp; to_string / 1 ] }","ref":"readme.html#transform-data","title":"Tarams - Transform data","type":"extras"},{"doc":"Tarams uses Valdi validation library. You can read more about Valdi here Basically it supports following validation validate inclusion/exclusion validate length for string and enumerable types validate number validate string format/pattern validate custom function validate required(not nil) or not product_schema = %{ sku : [ type : :string , required : true , length : [ min : 6 , max : 20 ] ] name : [ type : :string , required : true ] , quantity : [ type : :integer , number : [ min : 0 ] ] , type : [ type : :string , in : ~w(physical digital) ] , expiration_date : [ type : :naive_datetime , func : &amp; my_validation_func / 1 ] }","ref":"readme.html#validation","title":"Tarams - Validation","type":"extras"},{"doc":"If you find a bug or want to improve something, please send a pull request. Thank you!","ref":"readme.html#contributors","title":"Tarams - Contributors","type":"extras"}]